<?php 
class Allopass_Hipay_Model_Rule_Config extends Mage_Core_Model_Config_Data
{
	
	protected $_rule = null;
	protected $_ruleData = null;
	
	/**
	 * @return Allopass_Hipay_Model_Rule
	 */
	public function getRule()
	{
		if(is_null($this->_rule))
		{
			$this->_rule = Mage::getModel('hipay/rule');
		}
		
		return $this->_rule;
	}
	
	public function setRule($rule)
	{
		$this->_rule = $rule;
	}
	
	protected function _afterload()
	{
		
		parent::_afterload();
		$rule = Mage::getModel('hipay/rule');
		$rule->setMethodCode($this->_getMethodCode());
		
		if($this->getValue())
			$rule->load($this->getValue());
			
		$this->setRule($rule);
		
		return $this;
		
	}
	
	protected function _beforeSave()
	{
		$rule = Mage::getModel('hipay/rule')->load($this->getValue());
		
		$validateResult = $rule->validateData(new Varien_Object($this->_getRuleData()));
        if ($validateResult !== true) {
        	$errors = array();
            foreach($validateResult as $errorMessage) {
                $errors[] = $errorMessage;
            }
           Mage::throwException(new Exception(print_r($errors,true)));
           
        }
		
		$rule->setMethodCode($this->_getMethodCode());
		$rule->loadPost($this->_getRuleData());
	
		try{
			
			$rule->save();
		}
		catch (Exception $e)
		{
			Mage::logException($e);
		}		
		$this->setRule($rule);
		
		$this->setValue($rule->getId());
		
		parent::_beforeSave();
		return $this;
	}
	
	protected function _getMethodCode()
	{
		list($section,$group,$field) = explode("/", $this->getData('path'));
		return $group;
	}
	
	protected function _getRuleData()
	{
		if(is_null($this->_ruleData))
		{
			$post = Mage::app()->getRequest()->getPost();
			$this->_ruleData = array();
			if(isset($post['rule_' . $this->_getMethodCode()]['conditions']))
				$this->_ruleData['conditions'] = $post['rule_' . $this->_getMethodCode()]['conditions'];
		}
		
		return $this->_ruleData;
	}
}